#!/usr/local/bin/python3

import pandas as pd
import re,sys
from collections import OrderedDict

args = sys.argv

num_targetColumns = 5   # read 5 colums only
num_of_largeReads_to_report_per_column= 3
target_speciesName = args[1]

dbAddress = "sample_pandas_normal.xlsx"


################### 
def underscoreAdd(names):
    longestName = max(names, key = len)
    longestNameLen = len(longestName)
    newNames = []
    for name in names:
        name2 = re.sub("_", "-", name)
        nameWhiteSpace = name2 + "_" * (longestNameLen - len(name) + 2)
        newNames.append(nameWhiteSpace)
    return newNames

def calculate_percent(numbers_of_reads_FN):
    nums_int = list(map(int, numbers_of_reads_FN))
    sum_all = (sum(nums_int))
    nums_percent = []
    for num in nums_int:
        num = int(num)/sum_all * 100
        nums_percent.append(round(num, 2))
    return nums_percent

def check_sampleIDs_between_sheets():
    sampleIDs_environments = list(df_environments.index)
    #print("sampleIDs_environments", sampleIDs_environments)
    for sampleID_reads in names_column_reads:
        if sampleID_reads.startswith("#") or sampleID_reads == "Target":
            continue
        if not sampleID_reads in sampleIDs_environments:
            print(sampleID_reads)
            print("not found in sheet enviromnets")
            exit()

def screenout_targetSpeciesDetection():
    for name_column in names_column_reads:
        if name_column == "#OTU ID":
            continue
        if name_column == "Target":
            break
        sampleID = name_column
    
        df_s = df_reads.sort_values([sampleID], ascending=[False])
        names_species = list(df_s["Target"])
        names_species = underscoreAdd(names_species)
        numbers_of_reads = list(df_s[sampleID])
        percents_of_reads = calculate_percent(numbers_of_reads)
    
        records_found_target_spceistName = []
        for i in range(len(names_species)):
            if re.search("^" + target_speciesName + "_", names_species[i]) and percents_of_reads[i]:
                records_found_target_spceistName.append(names_species[i] + str(percents_of_reads[i]) + "%")
    
        ### Print out in screen
        if records_found_target_spceistName:
            print(sampleID)
            for record in records_found_target_spceistName:
                print(record)
            print("")

def make_excelFile_for_googleMap():
    list2d_spName_percent = []
    
    list_columnNames = []
    list_columnNames.append("SampleID")
    list_columnNames.append("Latitude")
    list_columnNames.append("Longitude")
    list_columnNames.append("Depth")
    list_columnNames.append("Day")
    list_columnNames.append("StartTime")
    for i in range(num_of_largeReads_to_report_per_column):
        list_columnNames.append(i + 1)
    list2d_spName_percent.append(list_columnNames)

    for name_column in names_column_reads:
        if name_column == "#OTU ID":
            continue
        if name_column == "Target":
            break
        sampleID = name_column
    
        list_spName_percents = []
        latitude = df_environments.loc[sampleID]["Latitude"]
        longitude = df_environments.loc[sampleID]["Longitude"]
        depth = df_environments.loc[sampleID]["Depth"]
        day = df_environments.loc[sampleID]["Day"]
        time_start = df_environments.loc[sampleID]["Time"]

        list_spName_percents.append(sampleID)
        list_spName_percents.append(latitude)
        list_spName_percents.append(longitude)
        list_spName_percents.append(depth)
        list_spName_percents.append(day)
        list_spName_percents.append(time_start)

        df_s = df_reads.sort_values([sampleID], ascending=[False])
        names_species = list(df_s["Target"])
        names_species = underscoreAdd(names_species)
        numbers_of_reads = list(df_s[sampleID])
        percents_of_reads = calculate_percent(numbers_of_reads)

        for i in range(len(names_species)):
            if i < num_of_largeReads_to_report_per_column and percents_of_reads[i]:
                list_spName_percents.append(names_species[i] + str(percents_of_reads[i]) + "%")
        list2d_spName_percent.append(list_spName_percents)
    
    
    df_reads_2 = pd.DataFrame(list2d_spName_percent)
    df_reads_2.to_excel("googleMap.xlsx", index=False, header=False)
    
    #df2 = df.transpose()
    #df2.to_excel("OUT.xlsx", index=False, header=False)


############################################################

#dfs = pd.read_excel("KS18-08KS19-4KS19-07.xlsx", sheet_name=None)
#print(list(dfs.keys()))
#exit()


df_reads = pd.read_excel(dbAddress, sheet_name="reads", usecols=range(num_targetColumns), index_col=0)
names_column_reads = list(df_reads.columns)
df_environments = pd.read_excel(dbAddress, sheet_name="environments", index_col=0)
check_sampleIDs_between_sheets()


screenout_targetSpeciesDetection()

make_excelFile_for_googleMap()

exit()

